// Code generated by protoc-gen-go-grpc. DO NOT EDIT.

package freeje_client

import (
	context "context"
	api "gitlab.com/BetaCompany/Freeje/sdk/go/api"
	grpc "google.golang.org/grpc"
	codes "google.golang.org/grpc/codes"
	status "google.golang.org/grpc/status"
)

// This is a compile-time assertion to ensure that this generated file
// is compatible with the grpc package it is being compiled against.
// Requires gRPC-Go v1.32.0 or later.
const _ = grpc.SupportPackageIsVersion7

// CallClient is the client API for Call service.
//
// For semantics around ctx use and closing/ending streaming RPCs, please refer to https://pkg.go.dev/google.golang.org/grpc/?tab=doc#ClientConn.NewStream.
type CallClient interface {
	//Запросить маршрутизацию исходящего вызова
	Route(ctx context.Context, in *api.VoipCall, opts ...grpc.CallOption) (*api.VoipCall, error)
	//Подтвердить получение входящего вызова
	Confirm(ctx context.Context, in *api.VoipCall, opts ...grpc.CallOption) (*api.VoipCall, error)
	//Отменить входящий вызов
	Reject(ctx context.Context, in *api.VoipCall, opts ...grpc.CallOption) (*api.VoipCall, error)
	//Завершить активный вызов
	Hangup(ctx context.Context, in *api.VoipCall, opts ...grpc.CallOption) (*api.VoipCall, error)
	//Запросить маршрутизацию исходящего вызова
	//На входе важно только CallNumber.dial
	//На выходе  CallNumber.price.intervalSec (интервал тарификации в секундах) + CallNumber.price.intervalRate (стоимость этого интервала)
	Estimate(ctx context.Context, in *CallNumber, opts ...grpc.CallOption) (*CallNumber, error)
}

type callClient struct {
	cc grpc.ClientConnInterface
}

func NewCallClient(cc grpc.ClientConnInterface) CallClient {
	return &callClient{cc}
}

func (c *callClient) Route(ctx context.Context, in *api.VoipCall, opts ...grpc.CallOption) (*api.VoipCall, error) {
	out := new(api.VoipCall)
	err := c.cc.Invoke(ctx, "/com.freeje.api.client.Call/Route", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *callClient) Confirm(ctx context.Context, in *api.VoipCall, opts ...grpc.CallOption) (*api.VoipCall, error) {
	out := new(api.VoipCall)
	err := c.cc.Invoke(ctx, "/com.freeje.api.client.Call/Confirm", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *callClient) Reject(ctx context.Context, in *api.VoipCall, opts ...grpc.CallOption) (*api.VoipCall, error) {
	out := new(api.VoipCall)
	err := c.cc.Invoke(ctx, "/com.freeje.api.client.Call/Reject", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *callClient) Hangup(ctx context.Context, in *api.VoipCall, opts ...grpc.CallOption) (*api.VoipCall, error) {
	out := new(api.VoipCall)
	err := c.cc.Invoke(ctx, "/com.freeje.api.client.Call/Hangup", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *callClient) Estimate(ctx context.Context, in *CallNumber, opts ...grpc.CallOption) (*CallNumber, error) {
	out := new(CallNumber)
	err := c.cc.Invoke(ctx, "/com.freeje.api.client.Call/Estimate", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

// CallServer is the server API for Call service.
// All implementations should embed UnimplementedCallServer
// for forward compatibility
type CallServer interface {
	//Запросить маршрутизацию исходящего вызова
	Route(context.Context, *api.VoipCall) (*api.VoipCall, error)
	//Подтвердить получение входящего вызова
	Confirm(context.Context, *api.VoipCall) (*api.VoipCall, error)
	//Отменить входящий вызов
	Reject(context.Context, *api.VoipCall) (*api.VoipCall, error)
	//Завершить активный вызов
	Hangup(context.Context, *api.VoipCall) (*api.VoipCall, error)
	//Запросить маршрутизацию исходящего вызова
	//На входе важно только CallNumber.dial
	//На выходе  CallNumber.price.intervalSec (интервал тарификации в секундах) + CallNumber.price.intervalRate (стоимость этого интервала)
	Estimate(context.Context, *CallNumber) (*CallNumber, error)
}

// UnimplementedCallServer should be embedded to have forward compatible implementations.
type UnimplementedCallServer struct {
}

func (UnimplementedCallServer) Route(context.Context, *api.VoipCall) (*api.VoipCall, error) {
	return nil, status.Errorf(codes.Unimplemented, "method Route not implemented")
}
func (UnimplementedCallServer) Confirm(context.Context, *api.VoipCall) (*api.VoipCall, error) {
	return nil, status.Errorf(codes.Unimplemented, "method Confirm not implemented")
}
func (UnimplementedCallServer) Reject(context.Context, *api.VoipCall) (*api.VoipCall, error) {
	return nil, status.Errorf(codes.Unimplemented, "method Reject not implemented")
}
func (UnimplementedCallServer) Hangup(context.Context, *api.VoipCall) (*api.VoipCall, error) {
	return nil, status.Errorf(codes.Unimplemented, "method Hangup not implemented")
}
func (UnimplementedCallServer) Estimate(context.Context, *CallNumber) (*CallNumber, error) {
	return nil, status.Errorf(codes.Unimplemented, "method Estimate not implemented")
}

// UnsafeCallServer may be embedded to opt out of forward compatibility for this service.
// Use of this interface is not recommended, as added methods to CallServer will
// result in compilation errors.
type UnsafeCallServer interface {
	mustEmbedUnimplementedCallServer()
}

func RegisterCallServer(s grpc.ServiceRegistrar, srv CallServer) {
	s.RegisterService(&Call_ServiceDesc, srv)
}

func _Call_Route_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(api.VoipCall)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(CallServer).Route(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/com.freeje.api.client.Call/Route",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(CallServer).Route(ctx, req.(*api.VoipCall))
	}
	return interceptor(ctx, in, info, handler)
}

func _Call_Confirm_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(api.VoipCall)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(CallServer).Confirm(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/com.freeje.api.client.Call/Confirm",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(CallServer).Confirm(ctx, req.(*api.VoipCall))
	}
	return interceptor(ctx, in, info, handler)
}

func _Call_Reject_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(api.VoipCall)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(CallServer).Reject(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/com.freeje.api.client.Call/Reject",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(CallServer).Reject(ctx, req.(*api.VoipCall))
	}
	return interceptor(ctx, in, info, handler)
}

func _Call_Hangup_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(api.VoipCall)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(CallServer).Hangup(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/com.freeje.api.client.Call/Hangup",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(CallServer).Hangup(ctx, req.(*api.VoipCall))
	}
	return interceptor(ctx, in, info, handler)
}

func _Call_Estimate_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(CallNumber)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(CallServer).Estimate(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/com.freeje.api.client.Call/Estimate",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(CallServer).Estimate(ctx, req.(*CallNumber))
	}
	return interceptor(ctx, in, info, handler)
}

// Call_ServiceDesc is the grpc.ServiceDesc for Call service.
// It's only intended for direct use with grpc.RegisterService,
// and not to be introspected or modified (even as a copy)
var Call_ServiceDesc = grpc.ServiceDesc{
	ServiceName: "com.freeje.api.client.Call",
	HandlerType: (*CallServer)(nil),
	Methods: []grpc.MethodDesc{
		{
			MethodName: "Route",
			Handler:    _Call_Route_Handler,
		},
		{
			MethodName: "Confirm",
			Handler:    _Call_Confirm_Handler,
		},
		{
			MethodName: "Reject",
			Handler:    _Call_Reject_Handler,
		},
		{
			MethodName: "Hangup",
			Handler:    _Call_Hangup_Handler,
		},
		{
			MethodName: "Estimate",
			Handler:    _Call_Estimate_Handler,
		},
	},
	Streams:  []grpc.StreamDesc{},
	Metadata: "client/call.proto",
}
